#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LawnGreen
#property indicator_color2  Tomato
#property indicator_color3  Blue
#property indicator_color4  White
#property indicator_width1  5
#property indicator_width2  5
#property indicator_width3  3
#property indicator_width4  2
#property indicator_maximum 100
#property indicator_minimum 0


//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    SF              = 5;
extern int    RsiPeriod       = 7;
extern int    RsiPrice        = 0;
extern double WP              = 4.236;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double upDa[];
double dnDb[];
double RsiMa[];
double TrendU[];
double trend[];
double emas[][3];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,upDa);     SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"QQE trend up");
   SetIndexBuffer(1,dnDb);     SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"QQE trend down");
   SetIndexBuffer(2,RsiMa);    SetIndexLabel(2,"QQE");
   SetIndexBuffer(3,TrendU);   SetIndexLabel(3,"QQE trigger");   
   SetIndexBuffer(4,trend); 
   
       //
       //
       //
       //
       //
      
          indicatorFileName = WindowExpertName();
          calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
          returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
          timeFrame         = stringToTimeFrame(TimeFrame);
      
       //
       //
       //
       //
       // 
       
   IndicatorShortName(timeFrameToString(timeFrame)+"  QQE ("+SF+","+RsiPeriod+")");
   return(0);
}

//
//
//
//
//

int deinit()
{   
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iEma 0
#define iEmm 1
#define iQqe 2

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { upDa[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     if (ArrayRange(emas,0) != Bars) { ArrayResize(emas,Bars);  }
     double alpha1 = 2.0/(SF+1.0);
     double alpha2 = 2.0/(RsiPeriod*2.0);
     for (i=limit, r=Bars-i-1; i>=0; i--,r++)
     {  
        RsiMa[i]   = RsiMa[i+1] + alpha1*(iRsi(iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i),RsiPeriod,i) - RsiMa[i+1]);
        emas[r][iEma] = emas[r-1][iEma] + alpha2*(MathAbs(RsiMa[i+1]-RsiMa[i]) - emas[r-1][iEma]);
        emas[r][iEmm] = emas[r-1][iEmm] + alpha2*(emas[r][iEma] - emas[r-1][iEmm]);

        //
        //
        //
        //
        //

           double rsi0 = RsiMa[i];
           double rsi1 = RsiMa[i+1];
           double dar  = emas[r  ][iEmm]*WP;
           double tr   = emas[r-1][iQqe];
           double dv   = tr;
   
              if (rsi0 < tr) { tr = rsi0 + dar; if ((rsi1 < dv) && (tr > dv)) tr = dv; }
              if (rsi0 > tr) { tr = rsi0 - dar; if ((rsi1 > dv) && (tr < dv)) tr = dv; }
         
        //
        //
        //
        //
        //
         
           TrendU[i]     = tr;
           emas[r][iQqe] = tr;
           upDa[i]       = EMPTY_VALUE;
           dnDb[i]       = EMPTY_VALUE;
           trend[i]      = trend[i+1];
              if (tr < RsiMa[i]) trend[i] = 1;
              if (tr > RsiMa[i]) trend[i] =-1;
              if (trend[i] == 1) { upDa[i]  = 100; dnDb[i] = 0; }
              if (trend[i] ==-1) { dnDb[i]  = 100; upDa[i] = 0; }
         
   }    
   manageAlerts();    
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period())); 
     for(i=limit; i>=0; i--)
     {
        int y = iBarShift(NULL,timeFrame,Time[i]);
           upDa[i]   = EMPTY_VALUE;
           dnDb[i]   = EMPTY_VALUE;
           RsiMa[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RsiPeriod,RsiPrice,WP,2,y);
           TrendU[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RsiPeriod,RsiPrice,WP,3,y); 
           trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RsiPeriod,RsiPrice,WP,4,y);
           if (trend[i] == 1) { upDa[i]  = 100; dnDb[i] = 0; }
           if (trend[i] ==-1) { dnDb[i]  = 100; upDa[i] = 0; }
               
      }
      manageAlerts();
return(0);
}   

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"crossing UP");
         if (trend[whichBar] == -1) doAlert(whichBar,"crossing DOWN");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" QQE "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," QQE " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," QQE "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}